'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = combineTransitions;

function combineTransitions() {
  for (var _len = arguments.length, transitions = Array(_len), _key = 0; _key < _len; _key++) {
    transitions[_key] = arguments[_key];
  }

  return function combinedTransition(location) {
    if (transitions.length === 0) {
      return Promise.resolve(undefined);
    }

    return new Promise(function (resolve, reject) {
      var index = 0;

      function tryNextTransition() {
        transitions[index++](location).then(function (page) {
          if (page) {
            resolve(page);
          } else if (index < transitions.length) {
            tryNextTransition();
          }
        })['catch'](reject);
      }

      tryNextTransition();
    });
  };
}

module.exports = exports['default'];